Index: mythcontrols/actionset.h
===================================================================
--- mythcontrols/actionset.h	(revision 10604)
+++ mythcontrols/actionset.h	(working copy)
@@ -26,39 +26,36 @@
 
 #include <qdict.h>
 
-/**
- * @brief The statically assigned context for jump point actions.
- */
+/** The statically assigned context for jump point actions. */
 #define JUMP_CONTEXT "JumpPoints"
 
-/**
- * @brief The name of global actions.
- */
+/** The name of global actions. */
 #define GLOBAL_CONTEXT "Global"
 
-
+/** Context is a grouping of actions */
 typedef QDict<Action> Context;
-typedef QValueList<ActionID> ActionList;
 
-
 /**
- * @class ActionSet
- * @brief Maintains consistancy between actions and keybindings.
+ * Action list is list of ActionIDs
  *
- * This class handles adding a removing bindings to keys.
+ * @todo Make a class out of this type and ensure that the list is
+ * sorted appropriatly.
  */
+typedef QValueList<ActionID> ActionList;
+
+
+/** Maintains consistancy between actions, contexts and keys. */
 class ActionSet
 {
 
 public:
 
-    /**
-     * @brief Create a new, empty set of action bindings.
-     */
+    /** Create a new, empty set of action bindings. */
     inline ActionSet() {};
 
     /**
-     * @brief Add an action.
+     * Add an action.
+     *
      * @param id The action identifier.
      * @param description The action description.
      * @param keys The keys for this action.
@@ -67,148 +64,207 @@
      * If the action has already been added, it will not be added
      * again.  There are no duplicate actions in the action set.
      */
-    bool addAction(const ActionID &id, const QString & description,
+    bool AddAction(const ActionID &id, const QString & description,
                    const QString &keys);
 
     /**
-     * @brief Add a binding.
+     * Add a binding.
+     *
      * @param id The action identifier.
      * @param key The symbolic name of the key.
      * @return true if the key was added otherwise, false.
      */
-    bool add(const ActionID &id, const QString &key);
+    bool Add(const ActionID &id, const QString &key);
 
     /**
-     * @brief Remove a key from an action identifier.
+     * Remove a key from an action identifier.
+     *
      * @param id The action identifier to remove from.
      * @param key The key to remove.
      */
-    bool remove(const ActionID &id, const QString &key);
+    bool Remove(const ActionID &id, const QString &key);
 
     /**
-     * @brief Replace a specific key in a specific action.
+     * Replace a specific key in a specific action.
+     *
      * @param id The action identifier.
      * @param newkey The new key.
      * @param oldkey The key to be replaced.
      */
-    bool replace(const ActionID &id, const QString &newkey,
+    bool Replace(const ActionID &id, const QString &newkey,
                  const QString &oldkey);
 
     /**
-     * @brief Get a list of all contexts in the action set.
+     * Get a list of all contexts in the action set.
+     *
      * @return A list of all contexts.
      */
-    QStringList * contextStrings(void) const;
+    QStringList * ContextStrings(void) const;
 
     /**
-     * @brief Get a list of all action in the action set.
+     * Get a list of all action in the action set.
+     *
      * @return A list of all actions in the action set.
      */
-    QStringList * actionStrings(const QString & context_name) const;
+    QStringList * ActionStrings(const QString & context_name) const;
 
     /**
-     * @brief Get a string containing all the keys in bound to an
-     * action.
+     * Get a string containing all the keys in bound to an action.
+     *
      * @param id The action's identifier.
      * @return null if there is no such action, otherwise, the keys.
      */
-    QString keyString(const ActionID &id) const;
+    QString KeyString(const ActionID &id) const;
 
     /**
-     * @brief Get the keys bound to an action by it's identifier.
+     * Get the keys bound to an action by it's identifier.
+     *
      * @param id The action identifier.
      * @return The keys used by the action.
      */
-    QStringList getKeys(const ActionID &id) const;
+    QStringList GetKeys(const ActionID &id) const;
 
     /**
-     * @brief Get the description of an action.
+     * Get all keys that are in use.
+     *
+     * @return A string list containing all of the keys.
+     */
+    QStringList * GetAllKeys(void) const;
+
+    /**
+     * Get the contexts, in which a key is bound.
+     *
+     * @return A string list containing the context names.
+     */
+    QStringList * GetKeyContexts(const QString &key) const;
+
+    /**
+     * Get all of the actions that are in use.
+     *
+     * @return A string list containing all of the actions.
+     */
+    QStringList *GetAllActions(void) const;
+
+    /**
+     * Get the description of an action.
+     *
      * @param id The action identifier.
      * @return The action description.
      */
-    const QString & getDescription(const ActionID &id) const;
+    const QString & GetDescription(const ActionID &id) const;
 
     /**
-     * @brief Get the actions bound to the specified key.
+     * Get the actions bound to the specified key.
+     *
      * @param key The key.
      * @return The list of actions, which are bound to the key.
      */
-    const ActionList & getActions(const QString &key) const;
+    inline const ActionList & GetActions(const QString &key) const
+    {
+        return m_KeyMap[key];
+    }
 
+
     /**
-     * @brief Get the appropriate container of modified actions based on
+     * Get the appropriate container of modified actions based on
      * context.
+     *
      * @return The appropriate container of modified actions.
      */
-    inline const ActionList & getModified(void) const { return _modified; }
+    inline const ActionList & GetModified(void) const
+    {
+        return m_Modified;
+    }
 
     /**
-     * @brief Determine if the action set has been modified.
+     * Determine if the action set has been modified.
+     *
      * @return True if changes have been made, otherwise, false.
      */
-    inline bool hasModified(void) const { return !(_modified.isEmpty()); }
+    inline bool HasModified(void) const
+    {
+        return !(m_Modified.isEmpty());
+    }
 
     /**
-     * @brief Mark an action as unmodified.
+     * Mark an action as unmodified.
+     *
      * @return true if the action was modified, and is set to unmodified.
      */
-    inline bool unmodify(const ActionID & id)
+    inline bool Unmodify(const ActionID & id)
     {
-        return (_modified.remove(id) > 0);
+        return (m_Modified.remove(id) > 0);
     }
 
     /**
-     * @brief Determine if an action has been modified.
+     * Determine if an action has been modified.
+     *
      * @param id The action identifier.
      * @return true if the action is modified, otherwise, false.
      */
-    inline bool isModified(const ActionID &id)const { return !unmodified(id); }
+    inline bool IsModified(const ActionID &id) const
+    {
+        return !Unmodified(id);
+    }
 
     /**
-     * @brief Determine if an action is still unmodified.
+     * Determine if an action is still unmodified.
+     *
      * @param id The action identifier.
      * @return true if the action has not been modified, otherwise, false.
      */
-    inline bool unmodified(const ActionID &id) const
+    inline bool Unmodified(const ActionID &id) const
     {
-        return (getModified().contains(id) == 0);
+        return (GetModified().contains(id) == 0);
     }
 
 protected:
 
     /**
-     * @brief Mark an action as modified.
+     * Mark an action as modified.
+     *
      * @param id The actio identifier.
      */
-    inline void modify(const ActionID &id)
+    inline void Modify(const ActionID &id)
     {
-        if (unmodified(id)) _modified.push_back(id);
+        if (Unmodified(id)) m_Modified.push_back(id);
     }
 
     /**
-     * @brief Get an action by its identifier.
+     * Get an action by its identifier.
+     *
      * @return A pointer to the action.
      */
-    inline Action * action(const ActionID &id) const
+    inline Action * GetAction(const ActionID &id) const
     {
-        return context(id.context()) ?
-            (*context(id.context()))[id.action()] : NULL;
+        return GetContext(id.context()) ?
+            (*GetContext(id.context()))[id.action()] : NULL;
     }
 
     /**
-     * @brief Get a context by its identifier.
+     * Get a context by its identifier.
+     *
      * @return A pointer to the context.
      */
-    inline Context * context(const QString & name) const
+    inline Context * GetContext(const QString & name) const
     {
-        return this->_contexts[name];
+        return this->m_Contexts[name];
     }
 
 private:
 
-    QMap<QString, ActionList> _keymap;
-    QDict<Context> _contexts;
-    ActionList _modified;
+    /** Maps keys to the actions the are bound */
+    QMap<QString, ActionList> m_KeyMap;
+
+    /** Dictionary of contexts (which contain actions) */
+    QDict<Context> m_Contexts;
+
+    /** Modified actions */
+    ActionList m_Modified;
+
+    /** map from action to the contexts it belongs to */
+    QMap<QString, QStringList> m_Actions;
+
 };
 
 #endif /* ACTIONSET_H */
Index: mythcontrols/action.h
===================================================================
--- mythcontrols/action.h	(revision 10604)
+++ mythcontrols/action.h	(working copy)
@@ -41,13 +41,15 @@
 public:
 
     /**
-     * @brief Create a new empty action.
+     * Create a new empty action.
+     *
      * @param description The actions description.
      */
-    inline Action(const QString & description) : _description(description) {}
+    inline Action(const QString & description) : m_Description(description) {}
 
     /**
-     * @brief Create a new action.
+     * Create a new action.
+     *
      * @param description The description of the action.
      * @param keys The key sequence (strings) that trigger the action.
      *
@@ -58,86 +60,91 @@
     Action(const QString & description, const QString & keys);
 
     /**
-     * @brief Get the action description.
+     * Get the action description.
+     *
      * @return The action description.
      */
-    inline const QString & getDescription() const { return this->_description; }
+    inline const QString & GetDescription() const
+    {
+        return this->m_Description;
+    }
 
     /**
-     * @brief Get the key sequence(s) that trigger this action.
+     * Get the key sequence(s) that trigger this action.
+     *
      * @return The key sequence(s) that trigger this action.
      */
-    inline const QStringList & getKeys() const { return this->_keys; }
+    inline const QStringList & GetKeys() const
+    {
+        return this->m_Keys;
+    }
 
     /**
-     * @brief Get the keys as a string.
+     * Get the keys as a string.
+     *
      * @return QString::null or a comma delimited string of keys.
      */
-    inline QString keyString() const { return _keys.join(","); }
+    inline QString KeyString() const
+    {
+        return m_Keys.join(",");
+    }
 
     /**
-     * @brief Add a key sequence to this action.
+     * Add a key sequence to this action.
+     *
      * @param key The key to add to the action.
      * @return true if the key was added otherwise, false.
      */
-    bool addKey(const QString & key);
+    bool AddKey(const QString & key);
 
     /**
-     * @brief Remove a key from this action.
+     * Remove a key from this action.
+     *
      * @param key The key to remove.
      * @return true if the key is removed, otherwise, false.
      */
-    inline bool removeKey(const QString & key) { return (keys().remove(key)>0); }
+    inline bool RemoveKey(const QString & key)
+    {
+        return (m_Keys.remove(key)>0);
+    }
 
     /**
-     * @brief Replace a key.
+     * Replace a key.
+     *
      * @param newkey The new key.
      * @param oldkey The old key, which is being replaced.
      */
-    bool replaceKey(const QString & newkey, const QString & oldkey);
+    bool ReplaceKey(const QString & newkey, const QString & oldkey);
 
     /**
-     * @brief Determine if the action already has a key.
+     * Determine if the action already has a key.
+     *
      * @param key The key to check for.
      * @return true if the key is already bound in this action,
      * otherwise, false is returned.
      */
-    bool hasKey(const QString & key) const;
+    bool HasKey(const QString & key) const;
 
     /**
-     * @brief Get the index of a key.
-     * @param key The string containing the key.
-     * @return The index of the key, which will be less than zero if the
-     * key does not exist.
-     */
-
-    /**
-     * @brief Determine if the action has any keys at all.
+     * Determine if the action has any keys at all.
+     *
      * @return true if the action has keys, otherwise, false.
      */
-    inline bool empty(void) const { return (_keys.size() > 0); }
+    inline bool IsEmpty(void) const
+    {
+        return (m_Keys.size() > 0);
+    }
 
-    /** @brief The maximum number of keys that can be bound to an action. */
+    /** The maximum number of keys that can be bound to an action. */
     static const unsigned short MAX_KEYS = 4;
 
-protected:
+private:
 
-    /**
-     * @brief Get a reference to the action description.
-     * @return A reference to the action description.
-     */
-    inline QString & description() { return this->_description; }
+    /** The actions description. */
+    QString m_Description;
 
-    /**
-     * @brief Get a reference to actions the key sequences.
-     * @return A reference to actions the key sequences.
-     */
-    inline QStringList & keys() { return this->_keys; }
-
-private:
-
-    QString _description;
-    QStringList _keys;
+    /** The keys bound to the action. */
+    QStringList m_Keys;
 };
 
 #endif /* ACTION_H */
